Gdk::PixbufLoader Class Reference
Inheritance diagram for Gdk::PixbufLoader:
[legend]
Collaboration diagram for Gdk::PixbufLoader:
[legend]

## Public Member Functions

| PixbufLoader (PixbufLoader&& src) noexcept
PixbufLoader& | operator= (PixbufLoader&& src) noexcept
| ~PixbufLoader () noexceptoverride
GdkPixbufLoader* | gobj ()
| Provides access to the underlying C GObject. More...
const GdkPixbufLoader* | gobj () const
| Provides access to the underlying C GObject. More...
GdkPixbufLoader* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_size (int width, int height)
void | write (const guint8* buf, gsize count)
| Causes the pixbuf loader to parse the next count bytes of an image. More...
void | close ()
| Informs a pixbuf loader that no further writes with PixbufLoader::write() will occur, so that it can free its internal loading structures. More...
Glib::RefPtr< Gdk::Pixbuf > | get_pixbuf ()
Glib::RefPtr< Gdk::PixbufAnimation > | get_animation ()
PixbufFormat | get_format () const
Glib::SignalProxy< void > | signal_area_prepared ()
| This signal is emitted when the pixbuf loader has allocated the pixbuf in the desired size. More...
Glib::SignalProxy< void, int, int, int, int > | signal_area_updated ()
| This signal is emitted when a significant area of the image being loaded has been updated. More...
Glib::SignalProxy< void > | signal_closed ()
| This signal is emitted when close() is called. More...
Glib::SignalProxy< void, int, int > | signal_size_prepared ()
| This signal is emitted when the pixbuf loader has been fed the initial amount of data that is required to figure out the size of the image that it will create. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions

static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< PixbufLoader > | create ()
| Creates a new pixbuf loader object. More...
static Glib::RefPtr< PixbufLoader > | create (const Glib::ustring& image_type, bool mime_type=false)
| Constructs a pixbuf loader object for a specific image type. More...

## Protected Member Functions

| PixbufLoader ()
| Constructs a pixbuf loader object. More...
| PixbufLoader (const Glib::ustring& image_type, bool mime_type=false)
| Constructs a pixbuf loader object for a specific image type. More...
virtual void | on_area_prepared ()
| This is a default handler for the signal signal_area_prepared(). More...
virtual void | on_area_updated (int x, int y, int width, int height)
| This is a default handler for the signal signal_area_updated(). More...
virtual void | on_closed ()
| This is a default handler for the signal signal_closed(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gdk::PixbufLoader > | wrap (GdkPixbufLoader* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members

Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Constructor & Destructor Documentation

Gdk::PixbufLoader::PixbufLoader | ( | PixbufLoader&& | src | ) |

noexcept

Gdk::PixbufLoader::~PixbufLoader | ( |  | ) |

override noexcept

Gdk::PixbufLoader::PixbufLoader | ( |  | ) |

protected

Constructs a pixbuf loader object.

Gdk::PixbufLoader::PixbufLoader | ( | const Glib::ustring & | image_type,
|  | bool | mime_type = `false`
| ) |  |

explicit protected

Constructs a pixbuf loader object for a specific image type.

Constructs a new pixbuf loader object that always attempts to parse image data as if it were an image of type image_type, instead of identifying the type automatically. Useful if you want an error if the image isn't the expected type, for loading image formats that can't be reliably identified by looking at the data, or if the user manually forces a specific type.

The image_type can be one of the types returned by Gdk::Pixbuf::get_formats(), or a MIME type.

Common MIME Types are listed here http://www.iana.org/assignments/media-types/ and here: http://www.freedesktop.org/Software/shared-mime-info

The list of non-mime-type image formats depends on what image loaders are installed, but typically "png", "jpeg", "gif", "tiff" and "xpm" are among the supported formats. To obtain the full list of supported image formats, call PixbufFormat::get_name() on each of the PixbufFormats returned by Gdk::Pixbuf::get_formats().

Parameters

  image_type | Name of the image format to be loaded with the image.
  mime_type | If this is true then the image_type is a MIME type.

Exceptions

  Gdk::PixbufError |

## Member Function Documentation

void Gdk::PixbufLoader::close | ( |  | ) |

Informs a pixbuf loader that no further writes with PixbufLoader::write() will occur, so that it can free its internal loading structures.

Also, tries to parse any data that hasn't yet been parsed; if the remaining data is partial or corrupt, an exception will be thrown. If you're just cancelling a load rather than expecting it to be finished, writing an empty `catch()` block to ignore errors is reasonable.

Exceptions

  Gdk::PixbufError |
  Glib::FileError |

static Glib::RefPtr<PixbufLoader> Gdk::PixbufLoader::create | ( |  | ) |

static

Creates a new pixbuf loader object.

Returns
  A newly-created pixbuf loader.

static Glib::RefPtr<PixbufLoader> Gdk::PixbufLoader::create | ( | const Glib::ustring & | image_type,
|  | bool | mime_type = `false`
| ) |  |

static

Constructs a pixbuf loader object for a specific image type.

Constructs a new pixbuf loader object that always attempts to parse image data as if it were an image of type image_type, instead of identifying the type automatically. Useful if you want an error if the image isn't the expected type, for loading image formats that can't be reliably identified by looking at the data, or if the user manually forces a specific type.

The image_type can be one of the types returned by Gdk::Pixbuf::get_formats(), or a MIME type.

Common MIME Types are listed here http://www.iana.org/assignments/media-types/ and here: http://www.freedesktop.org/Software/shared-mime-info

The list of non-mime-type image formats depends on what image loaders are installed, but typically "png", "jpeg", "gif", "tiff" and "xpm" are among the supported formats. To obtain the full list of supported image formats, call PixbufFormat::get_name() on each of the PixbufFormats returned by Gdk::Pixbuf::get_formats().

Parameters

  image_type | Name of the image format to be loaded with the image.
  mime_type | If this is true then the image_type is a MIME type.

Exceptions

  Gdk::PixbufError |

Glib::RefPtr<Gdk::PixbufAnimation> Gdk::PixbufLoader::get_animation | ( |  | ) |

PixbufFormat Gdk::PixbufLoader::get_format | ( |  | ) | const

Glib::RefPtr<Gdk::Pixbuf> Gdk::PixbufLoader::get_pixbuf | ( |  | ) |

static GType Gdk::PixbufLoader::get_type | ( |  | ) |

static

Get the GType for this class, for use with the underlying GObject type system.

GdkPixbufLoader* Gdk::PixbufLoader::gobj | ( |  | ) |

inline

Provides access to the underlying C GObject.

const GdkPixbufLoader* Gdk::PixbufLoader::gobj | ( |  | ) | const

inline

Provides access to the underlying C GObject.

GdkPixbufLoader* Gdk::PixbufLoader::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

virtual void Gdk::PixbufLoader::on_area_prepared | ( |  | ) |

protected virtual

This is a default handler for the signal signal_area_prepared().

virtual void Gdk::PixbufLoader::on_area_updated | ( | int | x,
|  | int | y,
|  | int | width,
|  | int | height
| ) |  |

protected virtual

This is a default handler for the signal signal_area_updated().

virtual void Gdk::PixbufLoader::on_closed | ( |  | ) |

protected virtual

This is a default handler for the signal signal_closed().

PixbufLoader& Gdk::PixbufLoader::operator= | ( | PixbufLoader&& | src | ) |

noexcept

void Gdk::PixbufLoader::set_size | ( | int | width,
|  | int | height
| ) |  |

Glib::SignalProxy< void > Gdk::PixbufLoader::signal_area_prepared | ( |  | ) |

This signal is emitted when the pixbuf loader has allocated the pixbuf in the desired size.

After this signal is emitted, applications can call get_pixbuf() to fetch the partially-loaded pixbuf.

Slot Prototype:
  `void on_my_area_prepared()`

Glib::SignalProxy< void,int,int,int,int > Gdk::PixbufLoader::signal_area_updated | ( |  | ) |

This signal is emitted when a significant area of the image being loaded has been updated.

Normally it means that a complete scanline has been read in, but it could be a different area as well. Applications can use this signal to know when to repaint areas of an image that is being loaded.

Parameters

  X | offset of upper-left corner of the updated area.
  y | Y offset of upper-left corner of the updated area.
  width | Width of updated area.
  height | Height of updated area.

Slot Prototype:
  `void on_my_area_updated(int x, int y, int width, int height)`

Glib::SignalProxy< void > Gdk::PixbufLoader::signal_closed | ( |  | ) |

This signal is emitted when close() is called.

It can be used by different parts of an application to receive notification when an image loader is closed by the code that drives it.

Slot Prototype:
  `void on_my_closed()`

Glib::SignalProxy< void,int,int > Gdk::PixbufLoader::signal_size_prepared | ( |  | ) |

This signal is emitted when the pixbuf loader has been fed the initial amount of data that is required to figure out the size of the image that it will create.

Applications can call set_size() in response to this signal to set the desired size to which the image should be scaled.

Parameters

  width | The original width of the image.
  height | The original height of the image

Slot Prototype:
  `void on_my_size_prepared(int width, int height)`

void Gdk::PixbufLoader::write | ( | const guint8 * | buf,
|  | gsize | count
| ) |  |

Causes the pixbuf loader to parse the next count bytes of an image.

It will return if the data was loaded successfully, and throw an exception if an error occurred. In the latter case, the loader will be closed, and will not accept further writes.

Parameters

  buf | Pointer to image data.
  count | Length of the buf buffer in bytes.

Exceptions

  Gdk::PixbufError |
  Glib::FileError |

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::PixbufLoader > wrap | ( | GdkPixbufLoader * | object,
|  | bool | take_copy = `false`
| ) |  |

related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gdkmm/pixbufloader.h